searchNodes=[{"doc":"Defines a factory that can be used in tests and database seeds files. Examples defmodule MyApp.Factory do use EctoStreamFactory , repo : MyApp.Repo def user_generator do gen all name &lt;- string ( :alphanumeric , min_length : 1 ) , age &lt;- integer ( 15 .. 80 ) do % User { name : name , age : age } end end def post_generator do gen all author &lt;- user_generator ( ) , body &lt;- string ( :alphanumeric , min_length : 10 ) do % Post { author : author , body : body } end end end","ref":"EctoStreamFactory.html","title":"EctoStreamFactory","type":"behaviour"},{"doc":"Same as build/2 , but raises an error if some key in overwrites does not exist in the generated struct, map or keyword list. Examples iex&gt; Factory . build! ( :user ) % User { id : nil , name : &quot;b&quot; , age : 28 } iex&gt; Factory . build! ( :user , name : &quot;foo&quot; , weight : 101 ) ** (EctoStreamFactory.MissingKeyError) MyApp.Factory.user_generator does not generate :weight field.","ref":"EctoStreamFactory.html#c:build!/2","title":"EctoStreamFactory.build!/2","type":"callback"},{"doc":"Takes a single instance from a StreamData gen/1 generator. If the generator returs a struct, map or keyword list, it also merges the result with overwrites . Examples iex&gt; Factory . build ( :user ) % User { id : nil , name : &quot;a&quot; , age : 33 } iex&gt; Factory . build ( :user , name : &quot;foo&quot; ) % User { id : nil , name : &quot;foo&quot; , age : 49 }","ref":"EctoStreamFactory.html#c:build/2","title":"EctoStreamFactory.build/2","type":"callback"},{"doc":"Same as build_list/3 , but raises an error if some key in overwites does not exist in the generated entities.","ref":"EctoStreamFactory.html#c:build_list!/3","title":"EctoStreamFactory.build_list!/3","type":"callback"},{"doc":"Same as build/2 , but instantiates a list of structs. Examples iex&gt; Factory . build_list ( 2 , :user , name : fn n -&gt; &quot;user \#{ n } &quot; end ) [ % User { id : nil , name : &quot;user1&quot; } , % User { id : nil , name : &quot;user2&quot; } ]","ref":"EctoStreamFactory.html#c:build_list/3","title":"EctoStreamFactory.build_list/3","type":"callback"},{"doc":"Same as insert/3 , but raises an error if some key in overwites does not exist in the generated struct.","ref":"EctoStreamFactory.html#c:insert!/3","title":"EctoStreamFactory.insert!/3","type":"callback"},{"doc":"Similar to build/2 , but expects a generator to return an Ecto.Schema struct to insert it into the database. Examples iex&gt; Factory . insert ( :user , [ email : &quot;duplicated@example.com&quot; ] , on_conflict : :nothing ) % User { id : 2 , email : &quot;duplicated@example.com&quot; }","ref":"EctoStreamFactory.html#c:insert/3","title":"EctoStreamFactory.insert/3","type":"callback"},{"doc":"Same as insert_list/4 , but raises an error if some key in overwites does not exist in the generated structs.","ref":"EctoStreamFactory.html#c:insert_list!/4","title":"EctoStreamFactory.insert_list!/4","type":"callback"},{"doc":"Same as insert/3 , but inserts a list of structs. Examples iex&gt; Factory . insert_list ( 3 , :user , role : &quot;admin&quot; ) [ % User { id : 3 , role : &quot;admin&quot; } , % User { id : 4 , role : &quot;admin&quot; } , % User { id : 5 , role : &quot;admin&quot; } ]","ref":"EctoStreamFactory.html#c:insert_list/4","title":"EctoStreamFactory.insert_list/4","type":"callback"},{"doc":"","ref":"EctoStreamFactory.html#t:amount/0","title":"EctoStreamFactory.amount/0","type":"type"},{"doc":"","ref":"EctoStreamFactory.html#t:generator_name/0","title":"EctoStreamFactory.generator_name/0","type":"type"},{"doc":"Same as options for Ecto.Repo.insert/2 .","ref":"EctoStreamFactory.html#t:insert_opts/0","title":"EctoStreamFactory.insert_opts/0","type":"type"},{"doc":"","ref":"EctoStreamFactory.html#t:overwrite_value/0","title":"EctoStreamFactory.overwrite_value/0","type":"type"},{"doc":"Keyword list or map where values can be of any literal types or one arity functions that generate sequential data.","ref":"EctoStreamFactory.html#t:overwrites/0","title":"EctoStreamFactory.overwrites/0","type":"type"},{"doc":"","ref":"EctoStreamFactory.MissingKeyError.html","title":"EctoStreamFactory.MissingKeyError","type":"exception"},{"doc":"","ref":"EctoStreamFactory.RepoNotSpecifiedError.html","title":"EctoStreamFactory.RepoNotSpecifiedError","type":"exception"},{"doc":"","ref":"EctoStreamFactory.UndefinedGeneratorError.html","title":"EctoStreamFactory.UndefinedGeneratorError","type":"exception"},{"doc":"EctoStreamFactory helps to utilize StreamData generators as Ecto factories . You can define one factory and use it in the following scenarios: Regular unit/integration/acceptance tests Property-based tests Load/stress/performance tests Database seeding HexDocs You can read about property-based testing in Fred Hebert's book .","ref":"readme.html","title":"README","type":"extras"},{"doc":"Add EctoStreamFactory dependency to mix.exs : def deps do [ { :ecto_stream_factory , &quot;~&gt; 0.2&quot; , only : [ :test , :dev ] } ] end Add :stream_data to your .formatter.exs : [ import_deps : [ :stream_data ] ] Create a factory module in test/support/factory.ex . Generator functions should have &quot;_generator&quot; suffix: defmodule MyApp.Factory do use EctoStreamFactory , repo : MyApp.Repo def user_generator do gen all name &lt;- string ( :alphanumeric , min_length : 1 ) , age &lt;- integer ( 15 .. 80 ) , email &lt;- email_generator ( ) do % MyApp.User { name : name , age : age , email : email } end end def post_generator do gen all author &lt;- user_generator ( ) , body &lt;- string ( :alphanumeric , min_length : 10 ) do % MyApp.Post { author : author , body : body } end end def email_generator do gen all username &lt;- string ( :alphanumeric , min_length : 1 ) , domain &lt;- member_of ( ~w(gmail.com protonmail.com yandex.com) ) do &quot; \#{ username } \#{ System . unique_integer ( [ :positive , :monotonic ] ) } @ \#{ domain } &quot; end end # handy for controller tests def user_params_generator do gen all user &lt;- user_generator ( ) , # you can also use Faker to generate human-friendly data last_name &lt;- constant ( Faker.Person . last_name ( ) ) , idempotency_key &lt;- constant ( Ecto.UUID . generate ( ) ) do %{ &quot;name&quot; =&gt; user . name , &quot;last_name&quot; =&gt; last_name , &quot;age&quot; =&gt; to_string ( user . age ) , &quot;email&quot; =&gt; user . email , &quot;idempotency_key&quot; =&gt; idempotency_key } end end end Make sure that mix.exs is configured to compile the factory for required environments: def project do [ elixirc_paths : elixirc_paths ( Mix . env ( ) ) ] end defp elixirc_paths ( env ) when env in [ :test , :dev ] , do : [ &quot;lib&quot; , &quot;test/support&quot; ] defp elixirc_paths ( _ ) , do : [ &quot;lib&quot; ] Optionally import the factory in .iex.exs to simplify its usage inside iex -S mix console on your development machine: import MyApp.Factory For a vanilla Elixir project you can import the factory in every test module with ExUnti.CaseTemplate . Create a file test/support/case.ex and add: defmodule MyApp.Case do use ExUnit.CaseTemplate using do quote do import MyApp.Factory end end end Then in your test files replase use ExUnit.Case with use MyApp.Case For a Phoenix project you can import the factory in support/data_case.ex , support/conn_case.ex , support/channel_case : defmodule MyAppWeb.ConnCase do using do quote do ... import MyApp.Factory end end end","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"iex&gt; build ( :email ) &quot;S1@protonmail.com&quot; iex&gt; build ( :user ) % User { id : nil , name : &quot;a&quot; , age : 33 , email : &quot;I2@yandex.com&quot; } iex&gt; build ( :user , name : &quot;Bob&quot; ) % User { id : nil , name : &quot;Bob&quot; , age : 28 , email : &quot;S3@gmail.com&quot; } iex&gt; build ( :post , text : &quot;Hello world&quot; ) % Post { id : nil , text : &quot;Hello world&quot; , author : % User { id : nil , name : &quot;b&quot; , age : 28 , email : &quot;l4@gmail.com&quot; } } iex&gt; build ( :user_params , %{ &quot;idempotency_key&quot; =&gt; &quot;123&quot; , &quot;new_param&quot; =&gt; &quot;foo&quot; } ) %{ &quot;name&quot; =&gt; &quot;2BO&quot; , &quot;last_name&quot; =&gt; &quot;Herman&quot; , &quot;age&quot; =&gt; &quot;32&quot; , &quot;email&quot; =&gt; &quot;a@gmail.com&quot; , &quot;idempotency_key&quot; =&gt; &quot;123&quot; , &quot;new_params&quot; =&gt; &quot;foo&quot; } iex&gt; build_list ( 2 , :user , name : fn n -&gt; &quot;user \#{ n } &quot; end ) [ % User { id : nil , name : &quot;user1&quot; , age : 51 , email : &quot;n5@gmail.com&quot; } , % User { id : nil , name : &quot;user2&quot; , age : 40 , email : &quot;O6@yandex.com&quot; } ] iex&gt; insert! ( :user ) % User { id : 1 , name : &quot;b&quot; , age : 23 , email : &quot;az7@gmail.com&quot; } iex&gt; insert! ( :user , gender : &quot;female&quot; ) ** (EctoStreamFactory.MissingKeyError) MyApp.Factory.user_generator does not generate :gender field. iex&gt; insert ( :user , [ email : &quot;az7@gmail.com&quot; ] , on_conflict : :nothing ) % User { id : nil , name : &quot;c&quot; , age : 44 , email : &quot;az7@gmail.com&quot; } iex&gt; insert ( :post , author : build ( :user , name : &quot;Jane&quot; ) ) % Post { id : 1 , text : &quot;kjfwi245lfh&quot; , author : % User { id : 2 , name : &quot;Jane&quot; , age : 34 , email : &quot;jhg8@yandex.com&quot; } } iex&gt; insert_list ( 2 , :user , age : 18 ) [ % User { id : 3 , name : &quot;bc&quot; , age : 18 , email : &quot;kl9@protonmail.com&quot; } , % User { id : 4 , name : &quot;bd&quot; , age : 18 , email : &quot;hj10@yandex.com&quot; } ]","ref":"readme.html#usage-in-regular-tests","title":"README - Usage in regular tests","type":"extras"},{"doc":"defmodule MyAppTest do use MyApp.Case , async : true use ExUnitProperties describe &quot;user properties&quot; do property &quot;contact info contains user name and email&quot; do check all user &lt;- user_generator ( ) do info = MyApp.User . contact_info ( user ) assert String . starts_with? ( info , user . name ) assert info =~ user . email end end property &quot;adult users older than 18&quot; do check all user &lt;- user_generator ( ) do assert MyApp.User . adult? ( user ) == user . age &gt;= 18 end end end end","ref":"readme.html#usage-in-property-based-tests","title":"README - Usage in property-based tests","type":"extras"},{"doc":"In priv/repo/seeds.exs import MyApp.Factory insert_list ( 100 , :post ) Then run it with mix run priv/repo/seeds.exs","ref":"readme.html#usage-in-seeding-the-database","title":"README - Usage in seeding the database","type":"extras"},{"doc":"How to conditionally generate values based on the result of previous generators? def user_generator do gen all language_code &lt;- member_of ( ~w(ru en) ) , last_name &lt;- user_last_name ( language_code ) do % User { language_code : language_code , last_name : last_name } end end defp user_last_name ( &quot;ru&quot; ) , do : member_of ( ~w(Ivanov Petrov) ) defp user_last_name ( &quot;en&quot; ) , do : member_of ( ~w(Smith Brown) ) How to modify the output of a generator inside another generator? def admin_generator do gen all admin &lt;- bind ( user_generator ( ) , fn user -&gt; Map . put ( user , :type , &quot;admin&quot; ) end ) do admin end end","ref":"readme.html#advanced-cases","title":"README - Advanced cases","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Enhancements Improve documentation Add more tests Bug fix Convert EctoStreamFactory.overwrites/0 to a map to prevent bugs","ref":"changelog.html#v0-2-2-2022-05-30","title":"Changelog - v0.2.2 (2022-05-30)","type":"extras"},{"doc":"Enhancements Improve documentation Update dependencies","ref":"changelog.html#v0-2-1-2022-05-28","title":"Changelog - v0.2.1 (2022-05-28)","type":"extras"},{"doc":"Enhancements Add build!/2 Add build_list!/3 Add insert!/3 Add insert_list!/4 All the new functions raise EctoStreamFactory.MissingKeyError error if a generated struct, map or keyword list cannot be fully merged with the provided attributes.","ref":"changelog.html#v0-2-0-2021-04-24","title":"Changelog - v0.2.0 (2021-04-24)","type":"extras"}]